#ifndef _AMBIENTLIGHT_H_
#define _AMBIENTLIGHT_H_

#include "RGBColor.h"

class AmbientLight
{
public:

  RGBColor fIntensity;

  AmbientLight() : fIntensity(0.0) {}
  AmbientLight(double r, double g, double b) : fIntensity(r, g, b) {}
  AmbientLight(double c) : fIntensity(c, c, c) {}
  AmbientLight(const RGBColor& c) : fIntensity(c) {}
  AmbientLight(const AmbientLight& a) : fIntensity(a.fIntensity) {}

  //To make things easier with multiplying colors
  double& operator[](int _i_)
  {
    if (_i_ == 0)
      return fIntensity[0];
    else if (_i_ == 1)
      return fIntensity[1];
    else
      return fIntensity[2];
  }

  const double& operator[](int _i_) const
  {
    if (_i_ == 0)
      return fIntensity[0];
    else if (_i_ == 1)
      return fIntensity[1];
    else
      return fIntensity[2];
  }

  void SetIntensity(double r, double g, double b);
  void SetIntensity(const RGBColor& v);
  RGBColor GetIntensity() const;
};

#endif