#ifndef _DEPTHBUFFER_H_
#define _DEPTHBUFFER_H_

#include <stdlib.h>
#include <memory.h>

class ostream;

class DepthBuffer
{
protected:

  double **fBuffer;
  int fWidth;
  int fHeight;

public:

  DepthBuffer() : fWidth(0), fHeight(0), fBuffer(NULL){}
  DepthBuffer(int _w_, int _h_, double _init_ = 1.0) : fWidth(_w_), fHeight(_h_) {SetSize(_w_, _h_); Clear(_init_);}
  DepthBuffer(int _x_, double _init_ = 1.0) : fWidth(_x_), fHeight(_x_) {SetSize(_x_, _x_); Clear(_init_);}
  DepthBuffer(const DepthBuffer& _z_) : fWidth(_z_.fWidth), fHeight(_z_.fHeight) {SetSize(_z_.fWidth, _z_.fHeight); memcpy(fBuffer, _z_.fBuffer, (_z_.fWidth * _z_.fHeight * sizeof(int)));}
  ~DepthBuffer();

  void SetSize(int w, int h);

  //Does comaprison to see if point is closer.  Sets new value in buffer by default
  bool DepthTest(int x, int y, double z, bool set = true);
  void SetDepth(int x, int y, double z);
  double GetDepth(int x, int y) const;
  void Clear(double _val_ = 1.0);

  DepthBuffer& operator=(const DepthBuffer& buf);
  friend ostream& operator<<(ostream& s, const DepthBuffer& a);
};

#endif
