#ifndef _FAKE_SHADOW_H_
#define _FAKE_SHADOW_H_

#include <memory.h>

#include "Matrix.h"
#include "Point.h"

class Vector;

class FakeShadow
{
protected:
  double fPlane[4];
  Matrix fShadowMatrix;

public:

  FakeShadow(){}

  void FindShadowPlane (const Point& p0, const Point& p1, const Point& p2);
  void ComputeShadowMatrix (const Vector& lightPos);

  double *GetShadowPlane(double *plane);

  Point ApplyShadow (const Point& p) const;
  friend Point ApplyShadow(const FakeShadow& s, const Point& p);
};

#endif
