#ifndef _MATRIX_H_
#define _MATRIX_H_

#include <math.h>
#include "Point.h"
#include "Vector.h"

class ostream;

class Matrix
{
public:
  double fMatrix[4][4];

  Matrix() {}

  void Invert();
  void Transpose();
  void SetIdentity();

  friend Matrix Invert(const Matrix& m);
  friend Matrix Transpose();
  friend Matrix IdentityMatrix();
  friend Matrix ZeroMatrix();
  friend Matrix TranslationMatrix(double x, double y, double z);
  friend Matrix RotationXMatrix(double angle);
  friend Matrix RotationYMatrix(double angle);
  friend Matrix RotationZMatrix(double angle);
  friend Matrix ScaleMatrix(double x, double y, double z);
  friend Matrix ViewMatrix(const Vector& LookAt, const Vector& Viewer, const Vector& UpL);
  friend Matrix PerspectiveMatrix (double D, double F, double H);
  friend Matrix PerspectiveMatrix (double depth);
  friend Matrix ShadowMatrix(double *groundPlane, const Vector& lightPos);

  friend Matrix operator*(const Matrix& A, const Matrix& B);

  Matrix& operator*=(const Matrix& M);
  friend ostream& operator<<(ostream& s, const Matrix& a);
};

#endif
