#ifndef _POINT_INL_
#define _POINT_INL_

#include "Point.h"

inline double Point::GetX() const
{
  return fX;
}

inline double Point::GetY() const
{
  return fY;
}

inline double Point::GetZ() const
{
  return fZ;
}

inline double Point::GetH() const
{
  return fH;
}

inline void Point::Set(double x, double y, double z, double h)
{
  fX = x;
  fY = y;
  fZ = z;
  fH = h;
}

inline void Point::Set(const Point& p)
{
  fX = p.fX;
  fY = p.fY;
  fZ = p.fZ;
  fH = p.fH;
}

inline void Point::Homogenize()
{
  fX /= fH;
  fY /= fH;
  fZ /= fH;
  fH /= fH;
}

inline Point Homogenize(const Point& p)
{
  Point hom = p;
  hom.Homogenize();
  return hom;
}

inline Point& Point::operator=(const Point& p)
{
  fX = p.fX;
  fY = p.fY;
  fZ = p.fZ;
  fH = p.fH;

  return *this;
}

//Comparisons disregard h
inline int operator==(const Point& a, const Point& b)
{
  return (a.fX == b.fX) && (a.fY == b.fY) && (a.fZ == b.fZ);
}

inline int operator<(const Point& a, const Point& b)
{
  return (a.fX < b.fX) && (a.fY < b.fY) && (a.fZ < b.fZ);
}

#endif
