#ifndef _SCANFILL_H_
#define _SCANFILL_H_

#ifndef WX_PRECOMP
#include "wx/wx.h"
#endif

#include "RGBColor.h"
#include "Point.h"

class SurfaceInfo;
class TextureMap;

typedef struct tScanPoint {
  int x;
  int y;
  double z;
  RGBColor i;
  Vector n;
  Point wc;
} ScanPoint;

typedef struct tEdge {
  int yUpper;
  double xIntersect, 
         dxPerScan, 
         zValue, 
         dzPerScan;
  RGBColor iValue,
           diPerScan;
  Vector nValue,
         dnPerScan;
  Point wcValue,
        dwcPerScan;
  struct tEdge * next;
/*
  int upperX;
  int upperY;
  double upperZ;
  int lowerX;
  int lowerY;
  double lowerZ;
  RGBColor lowerI;
  RGBColor upperI;
  Vector lowerN;
  Vector upperN;
  Point lowerWC;
  Point upperWC;
*/
} Edge;

class ScanFill
{
protected:
  SurfaceInfo *fCurrentSurfaceInfo;
  TextureMap *fCurrentTextureMap;

public:
  ScanFill() : fCurrentSurfaceInfo(NULL), fCurrentTextureMap(NULL) {}

  void Scan (wxDC& dc, int cnt, ScanPoint * pts);

  void SetSurfaceInfo(SurfaceInfo *info);
  void SetTextureMap(TextureMap *map);
  SurfaceInfo *GetSurfaceInfo() const;
  TextureMap *GetTextureMap() const;

protected:
  void _InsertEdge (Edge * list, Edge * edge);
  int _YNext (int k, int cnt, ScanPoint * pts);
  void _MakeEdgeRec (ScanPoint lower, ScanPoint upper, int yComp, Edge * edge, Edge * edges[]);
  void _BuildEdgeList (int cnt, ScanPoint * pts, Edge * edges[]);
  void _BuildActiveList (int scan, Edge * active, Edge * edges[]);
  void _FillScan (wxDC& dc, int scan, Edge * active);
  void _DeleteAfter (Edge * q);
  void _ResortActiveList (Edge * active);
  void _UpdateActiveList (int scan, Edge * active);
//  double _ComputeZ (Edge *e1, Edge *e2, int xs, int ys);
//  RGBColor _ComputeColor (int xs, int ys, double zs, Edge *e1, Edge *e2);
};

#endif
