#include <math.h>
#include "CylindricalTextureMap.h"
#include "Point.inl"

#ifndef M_PI
#define M_PI 3.14159265359
#endif

CylindricalTextureMap::CylindricalTextureMap(double radius, double height)
: fRadius(radius),
  fHeight(height)
{
}

CylindricalTextureMap::~CylindricalTextureMap()
{
}

RGBColor CylindricalTextureMap::Map3DTo2D(const Vector& v)
{
  RGBColor col;
  float x, y;
  int a, b;
  
  x = acos (v[0] / fRadius) / (2 * M_PI);
  y = v[1] / fHeight;

  //Value to translate texture point up from origin should probably be calculated,
  //But is hard coded for now
  y += 0.5;

  a = x * fMap.GetWidth();
  b = y * fMap.GetHeight();

  col[0] = ((double)(fMap.GetRed(a, b)))/255.0;
  col[1] = ((double)(fMap.GetGreen(a, b)))/255.0;
  col[2] = ((double)(fMap.GetBlue(a, b)))/255.0;

  return col;
}
