#include "wx/wxprec.h"
#include "MainWindow.h"

BEGIN_EVENT_TABLE(MainWindow, wxFrame)
    EVT_SIZE(MainWindow::OnSize)
    EVT_CLOSE(MainWindow::OnCloseWindow)
END_EVENT_TABLE()

MainWindow::MainWindow(char *title, int x, int y, int w, int h)
: wxFrame(NULL, -1, title, wxPoint(x, y), wxSize(w, h))
{
  SetAutoLayout( TRUE );
  CreateItems ();
}

MainWindow::~MainWindow()
{
}

void MainWindow::CreateItems ()
{
  fCanvas = new Canvas( this, -1 );
  wxLayoutConstraints *mainpanel = new wxLayoutConstraints;
  mainpanel->top.SameAs( this, wxTop);
  mainpanel->left.SameAs( this, wxLeft );
  mainpanel->right.SameAs( this, wxRight );
  mainpanel->bottom.SameAs( this, wxBottom );
  fCanvas->SetConstraints( mainpanel );
}

void MainWindow::OnCloseWindow(wxCloseEvent& WXUNUSED(event))
{
  Destroy();
}

void MainWindow::OnSize(wxSizeEvent& event)
{
  Layout();
}

bool MainWindow::Show ()
{
  return wxFrame::Show( TRUE );
}

bool MainWindow::Hide ()
{
  return wxFrame::Show( FALSE );
}
