#include <math.h>
#include "SphericalTextureMap.h"

#ifndef M_PI
#define M_PI 3.14159265359
#endif

SphericalTextureMap::SphericalTextureMap(double radius)
: fRadius(radius)
{
}

SphericalTextureMap::~SphericalTextureMap()
{
}

RGBColor SphericalTextureMap::Map3DTo2D(const Vector& v)
{
  RGBColor col;
  float phi, theta;
  float x, y;
  int a, b;
  
  phi = acos (v[0] / fRadius);
  y = ((M_PI/2.0) - phi)/(M_PI/4);

  theta = acos (v[0] / (fRadius*sin(phi)));
  x = theta/(2.0 * M_PI);

  a = x * fMap.GetWidth();
  b = y * fMap.GetHeight();

  col[0] = fMap.GetRed(a, b);
  col[1] = fMap.GetGreen(a, b);
  col[2] = fMap.GetBlue(a, b);

  return col;
}
